Package org.apache.uima.jcas.tcas

# Class Annotation

java.lang.Object
org.apache.uima.cas.impl.FeatureStructureImplC
org.apache.uima.jcas.cas.TOP
org.apache.uima.jcas.cas.AnnotationBase
org.apache.uima.jcas.tcas.Annotation

All Implemented Interfaces:
  `Cloneable`, `AnnotationBaseFS`, `FeatureStructure`, `AnnotationBaseImpl`, `AnnotationImpl`, `FeatureStructureImpl`, `AnnotationFS`

Direct Known Subclasses:
  `DocumentAnnotation`, `SourceDocumentInformation`

public class Annotation extends AnnotationBase implements AnnotationImpl
the JCas class model for the CAS type uima.cas.Annotation. It defines two integer valued features indicating the begin and end of the span being annotated. There is also a method to retrieve the spanned text as a string.

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class org.apache.uima.cas.impl.FeatureStructureImplC

  `FeatureStructureImplC.PrintReferences`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `_FeatName_begin`
  `static final String`
  `_FeatName_end`
  `static final String`
  `_TypeName`
  `static final int`
  `type`
  `static final int`
  `typeIndexID`

  ### Fields inherited from class org.apache.uima.jcas.cas.AnnotationBase

  `_FeatName_sofa`

  ### Fields inherited from class org.apache.uima.jcas.cas.TOP

  `_singleton`

  ### Fields inherited from class org.apache.uima.cas.impl.FeatureStructureImplC

  `_casView, _id, DISABLE_RUNTIME_FEATURE_VALIDATION, DISABLE_RUNTIME_FEATURE_VALUE_VALIDATION, IS_ENABLE_RUNTIME_FEATURE_VALIDATION, IS_ENABLE_RUNTIME_FEATURE_VALUE_VALIDATION, IS_V2_PRETTY_PRINT, V2_PRETTY_PRINT`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `Annotation()`
  Deprecated.
  ``
  `Annotation(TypeImpl t, CASImpl c)`
  used by generator Make a new AnnotationBase
  ``
  `Annotation(JCas jcas)`
  ``
  `Annotation(JCas jcas, int begin, int end)`
  Constructor with begin and end passed as arguments

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static Annotation`
  `_createMarkerAnnotation(JCas aJCas, int aBegin, int aEnd)`
  For internal use by `SelectFSs_impl`
  `final int`
  `compareAnnotation(Annotation other)`
  Compare two annotations, no type order
  `final int`
  `compareAnnotation(Annotation other, LinearTypeOrder lto)`
  Compare two annotations incl type order
  `final int`
  `compareAnnotationWithId(Annotation other)`
  Compare two annotations, with id compare
  `final int`
  `compareAnnotationWithId(Annotation other, LinearTypeOrder lto)`
  Compare two annotations, with type order, with id compare
  `final int`
  `getBegin()`
  Get the start position of the annotation as character offset into the text.
  `String`
  `getCoveredText()`
  Get the text covered by an annotation as a string.
  `final int`
  `getEnd()`
  Get the end position of the annotation as character offset into the text.
  `int`
  `getStart()`
  Deprecated.
  Use `getBegin()` instead.
  `int`
  `getTypeIndexID()`
  `final void`
  `setBegin(int v)`
  Set the start position of the annotation as character offset into the text.
  `final void`
  `setEnd(int v)`
  Set the end position of the annotation as character offset into the text.
  `void`
  `trim(IntPredicate aIsTrimChar)`
  Strips leading and trailing characters matching the given predicate by increasing/decreasing the begin/end offsets.

  ### Methods inherited from class org.apache.uima.jcas.cas.AnnotationBase

  `getSofa, getView, setFeatureValue`

  ### Methods inherited from class org.apache.uima.jcas.cas.TOP

  `_createJCasHashMapReserve, _createSearchKey`

  ### Methods inherited from class org.apache.uima.cas.impl.FeatureStructureImplC

  `_copyIntAndRefArraysEqTypesFrom, _copyIntAndRefArraysFrom, _copyIntArrayEqTypesFrom, _getBooleanValueNc, _getBooleanValueNc, _getByteValueNc, _getByteValueNc, _getDoubleValueNc, _getDoubleValueNc, _getFeatFromAdjOffset, _getFeatureValueNc, _getFeatureValueNc, _getFloatValueNc, _getFloatValueNc, _getIntLikeValue, _getIntValueNc, _getIntValueNc, _getLongValueNc, _getLongValueNc, _getRefValueCommon, _getShortValueNc, _getShortValueNc, _getStringValueNc, _getStringValueNc, _getTypeCode, _getTypeImpl, _getView, _id, _inSetSortedIndex, _isJCasHashMapReserve, _isPearTrampoline, _maybeGetBaseForPearFs, _maybeGetBaseForPearFs, _maybeGetPearFs, _maybeGetPearFs, _resetInSetSortedIndex, _setBooleanValueNcNj, _setBooleanValueNcNj, _setBooleanValueNfc, _setByteValueNcNj, _setByteValueNcNj, _setByteValueNfc, _setDoubleValueNcNj, _setDoubleValueNcNj, _setDoubleValueNfc, _setFeatureValueNcNj, _setFeatureValueNcNj, _setFeatureValueNcWj, _setFloatValueNcNj, _setFloatValueNcNj, _setFloatValueNfc, _setInSetSortedIndexed, _setIntLikeValue, _setIntLikeValueNcNj, _setIntValueCJ, _setIntValueNcNj, _setIntValueNcNj, _setIntValueNfc, _setIntValueNfcCJ, _setJCasHashMapReserve, _setLongValueCJ, _setLongValueNcNj, _setLongValueNcNj, _setLongValueNfc, _setLongValueNfcCJ, _setPearTrampoline, _setRefValueCJ, _setRefValueCommon, _setRefValueCommonWj, _setRefValueNfcCJ, _setShortValueNcNj, _setShortValueNcNj, _setShortValueNfc, _setStringValueNcNj, _setStringValueNcWj, _setStringValueNfc, _setTypeImpl, addStringOrPrimitive, addToIndexes, addToIndexes, addToIndexes, clone, compare, equals, getAddress, getBooleanValue, getByteValue, getCAS, getCASImpl, getDoubleValue, getFeatureValue, getFeatureValueAsString, getFloatValue, getIntValue, getLongValue, getLowLevelCas, getShortValue, getStringValue, getType, hashCode, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrint, prettyPrintShort, removeFromIndexes, removeFromIndexes, removeFromIndexes, setBooleanValue, setByteValue, setDoubleValue, setFeatureValueFromString, setFloatValue, setIntValue, setLongValue, setShortValue, setStringValue, toShortString, toString, toString, wrapGetIntCatchException`

  ### Methods inherited from class java.lang.Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.uima.cas.AnnotationBaseFS

  `getView`

  ### Methods inherited from interface org.apache.uima.cas.text.AnnotationFS

  `coveredBy, coveredBy, covering, covering, following, following, overlapping, overlapping, overlappingAtBegin, overlappingAtBegin, overlappingAtEnd, overlappingAtEnd, preceding, preceding, trim`

  ### Methods inherited from interface org.apache.uima.cas.FeatureStructure

  `_getTypeCode, _id, clone, equals, getAddress, getBooleanValue, getByteValue, getCAS, getDoubleValue, getFeatureValue, getFeatureValueAsString, getFloatValue, getIntValue, getJCas, getLongValue, getShortValue, getStringValue, getType, hashCode, setBooleanValue, setByteValue, setDoubleValue, setFeatureValue, setFeatureValueFromString, setFloatValue, setIntValue, setLongValue, setShortValue, setStringValue`

  ### Methods inherited from interface org.apache.uima.cas.impl.FeatureStructureImpl

  `prettyPrint, prettyPrint, prettyPrint, prettyPrint, toString`

- ## Field Details

  - ### _TypeName

    public static final String _TypeName
    See Also:
      - Constant Field Values

  - ### _FeatName_begin

    public static final String _FeatName_begin
    See Also:
      - Constant Field Values

  - ### _FeatName_end

    public static final String _FeatName_end
    See Also:
      - Constant Field Values

  - ### typeIndexID

    public static final int typeIndexID

  - ### type

    public static final int type

- ## Constructor Details

  - ### Annotation

    @Deprecated protected Annotation()
    Deprecated.

  - ### Annotation

    public Annotation(JCas jcas)

  - ### Annotation

    public Annotation(TypeImpl t, CASImpl c)
    used by generator Make a new AnnotationBase
    Parameters:
      `c` - -
      `t` - -

  - ### Annotation

    public Annotation(JCas jcas, int begin, int end)
    Constructor with begin and end passed as arguments
    Parameters:
      `jcas` - JCas
      `begin` - begin offset
      `end` - end offset

- ## Method Details

  - ### getTypeIndexID

    public int getTypeIndexID()
    Overrides:
      `getTypeIndexID` in class `AnnotationBase`
    Returns:
      the type array index

  - ### getBegin

    public final int getBegin()
    Description copied from interface: `AnnotationFS`
    Get the start position of the annotation as character offset into the text. The smallest possible start position is `0`, the offset of the first character in the text.
    Specified by:
      `getBegin` in interface `AnnotationFS`
    Returns:
      The start position.

  - ### setBegin

    public final void setBegin(int v)
    Description copied from interface: `AnnotationFS`
    Set the start position of the annotation as character offset into the text. The smallest possible start position is `0`, the offset of the first character in the text.
    Specified by:
      `setBegin` in interface `AnnotationFS`
    Parameters:
      `v` - The start position.

  - ### getEnd

    public final int getEnd()
    Description copied from interface: `AnnotationFS`
    Get the end position of the annotation as character offset into the text. The end position points at the first character after the annotation, such that `(getEnd()-getBegin()) == getCoveredText().length()`.
    Specified by:
      `getEnd` in interface `AnnotationFS`
    Returns:
      The end position.

  - ### setEnd

    public final void setEnd(int v)
    Description copied from interface: `AnnotationFS`
    Set the end position of the annotation as character offset into the text. The end position points at the first character after the annotation, such that `(getEnd()-getBegin()) == getCoveredText().length()`.
    Specified by:
      `setEnd` in interface `AnnotationFS`
    Parameters:
      `v` - The end position position.

  - ### getCoveredText

    public String getCoveredText()
    Description copied from interface: `AnnotationFS`
    Get the text covered by an annotation as a string. If `docText` is your document text and `annot` an annotation, then `annot.getCoveredText().equals(docText.substring(annot.getBegin(), annot.getEnd()))`.
    Specified by:
      `getCoveredText` in interface `AnnotationFS`
    Returns:
      -
    See Also:
      - `AnnotationFS.getCoveredText()`

  - ### getStart

    @Deprecated public int getStart()
    Deprecated.
    Use `getBegin()` instead.
    Returns:
      the Annotation "begin" feature value

  - ### compareAnnotation

    public final int compareAnnotation(Annotation other)
    Compare two annotations, no type order
    Parameters:
      `other` - -
    Returns:
      -

  - ### compareAnnotation

    public final int compareAnnotation(Annotation other, LinearTypeOrder lto)
    Compare two annotations incl type order
    Parameters:
      `other` - -
      `lto` - -
    Returns:
      -

  - ### compareAnnotationWithId

    public final int compareAnnotationWithId(Annotation other)
    Compare two annotations, with id compare
    Parameters:
      `other` - -
    Returns:
      -

  - ### compareAnnotationWithId

    public final int compareAnnotationWithId(Annotation other, LinearTypeOrder lto)
    Compare two annotations, with type order, with id compare
    Parameters:
      `other` - -
      `lto` - -
    Returns:
      -

  - ### trim

    public void trim(IntPredicate aIsTrimChar)
    Description copied from interface: `AnnotationFS`
    Strips leading and trailing characters matching the given predicate by increasing/decreasing the begin/end offsets.
    Specified by:
      `trim` in interface `AnnotationFS`
    Parameters:
      `aIsTrimChar` - the predicate used to identify whether a given codepoint is whitespace.
    See Also:
      - `AnnotationFS.trim()`

  - ### _createMarkerAnnotation

    public static Annotation _createMarkerAnnotation(JCas aJCas, int aBegin, int aEnd)
    For internal use by `SelectFSs_impl`